#
# u2df02.rb
#
# $Id: u2df02.rb,v 1.1 2000/11/22 14:35:57 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


NX = 19
NY = 19
XMIN = 0
XMAX = 360
DX1 = 10
DX2 = 60
YMIN = -90
YMAX = 90
MY = 7
NC = 3
DRAD = PI/180
DZ = 0.05
p = NArray.sfloat(NX, NY)
uy1 = NArray.sfloat(NY)
uy2 = NArray.sfloat(MY)

#-- data ---
ch = ['SP ', '60S', '30S', 'EQ ', '30N', '60N', 'NP ']

for j in 0..NY-1
  for i in 0..NX-1
    alon = (XMIN + (XMAX-XMIN)*i/(NX-1)) * DRAD
    alat = (YMIN + (YMAX-YMIN)*j/(NY-1)) * DRAD
    slat = sin(alat)
    p[i,j] = cos(alon) * (1-slat**2) * sin(2*PI*slat) + DZ
  end
end

uy1.indgen(YMIN, (YMAX-YMIN)/(NY-1))
uy1 = NMath.sin(uy1*DRAD)
uy2.indgen(YMIN, (YMAX-YMIN)/(MY-1))
uy2 = NMath.sin(uy2*DRAD)

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm

grswnd(XMIN, XMAX, uy1[0], uy1[NY-1])
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

uxaxdv('B', DX1, DX2)
uxaxdv('T', DX1, DX2)
uxsttl('B', 'LONGITUDE', 0.0)

uyaxlb('L', uy1, uy2, ch, NC)
uyaxlb('R', uy1, uy2, ch, NC)
uysttl('L', 'LATITUDE', 0.0)

uwsgxb(XMIN, XMAX, NX)
uwsgya(uy1)

udsfmt('(F6.1)')
udgclb(p, 0.2)
udsclv(0.1, 1, 4, ' ', 0.01)

udcntr(p)

grcls

